<?php
define('DB_HOST', 'localhost');
define('DB_NAME', 'wordpress');
define('DB_USER', 'root');
define('DB_PASSWORD', '');

/* Data format

This widget expect data to be loaded in the following format. The PHP script below is using WordPress tables to format data that way but you could use any other BackEnd language to do so.

[
	{
		"post_title":"How to automatically checkout the latest tag of a Git repository",
		"post_content":"Now that you know how to automatically tag a Git repository an interesting command to know about is \"How to automatically checkout the latest tag of a Git repository\". Let's imagine that you want to a...",
		"post_name":"how-to-automatically-checkout-the-latest-tag-of-a-git-repository",
		"post_date":"2013-10-04 18:31:00",
		"ID":"1292"
	},
	{
		"post_title":"Sidr",
		"post_content":"Sidr is a jQuery plugin for creating side menus. It is the library that I use to create \"Previous\" and \"Next\" post button on my Open Sourced WordPress theme (the one you are using righ...",
		"post_name":"sidr",
		"post_date":"2013-09-24 20:16:04",
		"ID":"1279"
	}
]
*/

/* settings */
session_start();
$number_of_posts = 2; //2 at a time
$_SESSION['posts_start_angular'] = $_SESSION['posts_start_angular'] ? $_SESSION['posts_start_angular'] : $number_of_posts;

/* loading of stuff */
if (isset($_GET['start'])) {
	/* spit out the posts within the desired range */
	$posts = get_posts($_GET['start'], $_GET['desiredPosts']);
	// decode the result to know the exact length of the result
	// It could be 2 in this case or less
	$postsDecoded = json_decode($posts);
	// If the result is not empty we update the session
	if (!empty($postsDecoded)) {
		/* save the user's "spot", so to speak */
		$_SESSION['posts_start_angular']+= count($postsDecoded);
	}
	echo get_posts($_GET['start'], $_GET['desiredPosts']);
	/* kill the page */
	die();
}

/* grab stuff */

function get_posts($start = 0, $number_of_posts = 2) {
	/* connect to the db */
	$connection = mysql_connect(DB_HOST, DB_USER, DB_PASSWORD);
	mysql_select_db(DB_NAME, $connection);
	$posts = array();
	/* get the posts */
	$query = "SELECT post_title, post_content, post_name, post_date, ID FROM wp_posts WHERE post_status = 'publish' AND post_type='post' ORDER BY post_date DESC LIMIT $start,$number_of_posts";
	$result = mysql_query($query);
	while ($row = mysql_fetch_assoc($result)) {
		// Remove html tag and truncate the content
		$row['post_content'] = substr(strip_tags($row['post_content']), 0, 200) . '...';
		$posts[] = $row;
	}
	/* return the posts in the JSON format */
	return json_encode($posts);
}
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
		<title>Demo: Create a “load more” widget using AngularJS, Ajax and Bootstrap 3</title>
		<meta name="viewport" content="width=device-width, initial-scale=1.0">
		<link href="//netdna.bootstrapcdn.com/bootstrap/3.0.0/css/bootstrap.min.css" type="text/css" rel="stylesheet">
		<script src="https://ajax.googleapis.com/ajax/libs/angularjs/1.2.0-rc.2/angular.min.js"></script>
		<script src="https://ajax.googleapis.com/ajax/libs/angularjs/1.2.0-rc.2/angular-resource.min.js"></script>

		<script type="text/javascript">
			var start = <?php echo $_SESSION['posts_start_angular']; ?>;
			var initialPosts = <?php echo get_posts(0, $_SESSION['posts_start_angular']); ?>;
			var desiredPosts = <?php echo $number_of_posts; ?>;

			angular.module('demo', ['demoFactory']);

			angular.module('demoFactory', ['ngResource']).factory('Demo', function($resource) {
				return $resource('?desiredPosts=:desiredPosts&start=:start', {}, {
					// Declaration of custom action that should extend the default set of resource actions
					query: {
						isArray: true,
						cache: false
					}
				});
			});

			function MyCtrl($scope, Demo, $timeout) {
				$scope.start = start;
				$scope.list = initialPosts;
				$scope.alert = '';
				$scope.loadMore = function(e) {
					Demo.query({
						start: $scope.start,
						desiredPosts: desiredPosts
					}, function(data) {
						if (data.length > 0) {

							// Update the total number of items
							$scope.start += data.length;
							// load items on the page
							$scope.list = $scope.list.concat(data);
							// Make sure we execute the following code after the DOM
							// is succesfully loaded using $timeout
							$timeout(function() {
								// Get the ID of the first Item to load
								var firstAddedItemID = '#item-' + $scope.list[$scope.list.length - desiredPosts]['ID'];
								// Get the needed DOM elements
								var $firstAddedItem = document.querySelector(firstAddedItemID);
								var $widgetContent = document.querySelector('#widget .content');
								// Scroll to the first item loaded + 15 extra px ($widgetContent's padding)
								$widgetContent.scrollTop = $firstAddedItem.offsetTop - ($widgetContent.offsetTop + 15);
							}, 0);
						}
						else {
							// Set all needed DOM elements using JQlite
							$widget = angular.element(document.querySelector('#widget'));
							$widgetHeader = angular.element(document.querySelector('.panel-heading'));
							$button = angular.element(e.srcElement);
							$alert = angular.element('<span class="pull-right">No more data!</span>');

							// insert the empty message
							$widget.addClass('panel-warning');
							$widgetHeader.prepend($alert);
							// Remove the more button
							$button.remove();

							// remove the empty message and the warning style after 4 seconds
							window.setTimeout(function() {
								$alert.remove();
								$widget.removeClass('panel-warning');
							}, 4000);
						}
					});
				}
			}

			MyCtrl.$inject = ['$scope', 'Demo', '$timeout'];
		</script>
		<style>
			#widget{
				max-width: 500px;
				margin: 20px auto 20px;
			}
		</style>
	</head>
	<body data-ng-app="demo">
		<a class="btn btn-info btn-lg pull-right" target="_blank" href="http://demos.julienrenaux.fr/#/demos/angularJS/load-more-widget-using-bootstrap-3-angularjs-php-and-ajax">Demo</a>
		<!-- Starting widget -->
		<div id="widget" class="panel panel-default" data-ng-controller="MyCtrl">
			<div class="panel-heading">Widget Title <span class="badge">{{start}}</span></div>
			<div class="content panel-body" style="height: 300px; overflow: auto; margin: 0px;">
				<div id="item-{{item.ID}}" class="item" data-ng-repeat="item in list">
					<img class="thumbnail pull-left" width="50px" height="50px"	src="img/50x50.gif"	style="margin: 0px 10px 5px 0px;">
					<a href="#">
						<h4 style="margin: 5px 0px;">{{item.post_title}}</h4>
					</a>
					<p>
						<small>{{item.post_content}}</small>
					</p>
					<div class="well well-sm">
						{{item.post_date}}
					</div>
				</div>
			</div>
			<button class="more btn btn-primary btn-block" data-ng-click="loadMore($event)">
				More <span class="caret"></span>
			</button>
		</div>
		<!-- Ending widget -->
	</body>
</html>
